(* Copyright 2006, 2008 Andrew W. Appel, Robert Dockins and Xavier Leroy
 * This file is part of the List-machine Benchmark.
 * The List-machine Benchmark is licensed under GPLv3; see LICENSE.
 *)

Require Export Arith.

Section CompleteInduction.
  Variable P : nat -> Prop.

  Lemma CompleteInduction_aux :
      (forall n:nat, (forall m:nat, m < n -> P m) -> P n) ->
      (forall n x, x <= n -> P x).

    intro H; induction n; intros x Hx.

    apply H; intros m Hm.
    inversion Hx; subst; inversion Hm.

    apply H; intros m Hm; apply IHn.
    cut (S m <= S n); auto with arith.
    apply le_trans with x; auto.
   Qed.

  Theorem CompleteInduction :
      (forall n:nat, (forall m:nat, m < n -> P m) -> P n) ->
      forall x:nat, P x.

    intros H x; apply CompleteInduction_aux with x; auto.
   Qed.

End CompleteInduction.
